# encoding: utf-8
#
#= TriggersController
#
#Authors:: パーソナルメディア株式会社
#Copyright:: Copyrigyt (C) Personal Media Corp., 2013. All rights reserved.
#



#== /api/vi/triggers に対応したコントローラ
class TriggersController < ApplicationController


  #=== /api/vi/triggers GET メソッドを処理する
  def index

   if params.length < 3
       head :bad_request and return
   end

    m = Mongo::Connection.new(MONGO_SERVER,MONGO_PORT)
    db = m.db(MONGO_DB)
    coll = db.collection(MONGO_COLLECTION)

    if params[:name].present?
      find_hash['name'] = params[:name]
    end

    if params[:type].present?
      find_hash['type'] = params[:type]
    end

    if params[:value].present?
      find_hash['value'] = params[:value]
    end

    if params[:callback].present?
      find_hash['callback'] = params[:callback]
    end
    if params[:target].present?
      tmp=params[:target].split(",")
      if tmp.size == 1
        find_hash['ucode'] = tmp[0]
        find_hash['ucode'] = 'ucode_' + tmp[0] unless /^ucode_/ =~ tmp[0]
      else
        tmp_array = []
        tmp.each do |v|
          v = 'ucode_' + v unless /^ucode_/ =~ v
          tmp_array.push({ 'ucode' => v })
        end
        find_hash["$or"] = tmp_array
      end
    end

    offset = 0
    if params[:offset].present?
      offset = params[:offset].to_i
    end

    limit = 0
    if params[:limit].present?
      limit = params[:limit].to_i
    end

    # limit 値が大き過ぎる
    if limit > 500
      head 413 and return
    end

    arr = []
    tmp = {}
    if limit > 0 then
      coll.find( find_hash ).skip(offset).limit(limit).each do |cc|
        tmp.merge!(cc)
        arr << tmp
      end
    else
      coll.find( find_hash ).skip(offset).each do |cc|
        tmp.merge!(cc)
        arr << tmp
      end
    end
    
    result = {}
    result['triggers'] = arr
    result['remains'] = 'false'

    respond_to do |format|
      format.json      {  render :json => JSON.pretty_generate(result) } 
      format.xml       {  render :xml  => result }
    end
    
  end

  #=== /api/vi/triggers POST メソッドを処理する
  def create
    
    data = ActiveSupport::JSON.decode(request.body.string)

    data['ucode'] = 'ucode_' + ucodeDistributor('trigger')

    data['target'].each do |v|
      v.sub!('urn:ucode:_','ucode_')
      v.sub!('<','')
      v.sub!('>','')
    end

    data['callback'] = URI.decode(data['callback'] )

    m = Mongo::Connection.new( MONGO_SERVER ,MONGO_PORT)
    db = m.db(MONGO_DB)
    db[MONGO_DB].insert(data)
    
    
    return_hash = { 'ucode' => [] }
    return_hash['ucode'].push( '<urn:ucode:_'  + data['ucode'].sub('ucode_','') + '>'  )
    

    respond_to do |format|
      format.xml   { render :xml => return_hash }
      format.json  { render :json => return_hash }
    end

  end
  

  #=== /api/vi/triggers/id: GET メソッドを処理する
  def show

   if !params[:id].present?
     head :bad_request and return
   end
    
    m = Mongo::Connection.new(MONGO_SERVER,MONGO_PORT)
    db = m.db(MONGO_DB)
    coll = db.collection(MONGO_COLLECTION)

    find_hash = {}

    find_hash['ucode'] = params[:id]
    find_hash['ucode'] = 'ucode_' + params[:id]  unless /^ucode_/ =~ params[:id]

    arr = []
    tmp = {}

    coll.find( find_hash ).each do |cc|
      tmp.merge!(cc)
    end
    
    respond_to do |format|
      format.json      {  render :json => JSON.pretty_generate(tmp) } 
      format.xml       {  render :xml  => tmp }
    end

  end



  #=== /api/vi/triggers PUT メソッドを処理する
  def update
    
    if !params[:id].present?
      header 400 and return
    end

    data = ActiveSupport::JSON.decode(request.body.string)

    ucode = params[:id]
    ucode = 'ucode_' + params[:id] unless /ucode_/ =~ params[:id]

    find_hash = {'ucode' => ucode }

    if data['target'].present?
      data['target'].each do |v|
        v.sub!('urn:ucode:_','ucode_')
        v.sub!('<','')
        v.sub!('>','')
      end
    end

    if data['callback'].present?
      data['callback'] = URI.decode(data['callback'] )
    end

    m = Mongo::Connection.new( MONGO_SERVER ,MONGO_PORT)
    db = m.db(MONGO_DB)

    data.each do |k,v|
      update_hash = { '$set' => {k => v} }
      db[MONGO_DB].update(find_hash, update_hash)
    end

    head 204

  end
  

  #=== /api/vi/triggers/id: GET メソッドを処理する
  def show

   if !params[:id].present?
     head :bad_request and return
   end
    
    m = Mongo::Connection.new(MONGO_SERVER,MONGO_PORT)
    db = m.db(MONGO_DB)
    coll = db.collection(MONGO_COLLECTION)

    find_hash = {}

    find_hash['ucode'] = params[:id]
    find_hash['ucode'] = 'ucode_' + params[:id]  unless /^ucode_/ =~ params[:id]

    arr = []
    tmp = {}

    p find_hash
    coll.find( find_hash ).each do |cc|
      tmp.merge!(cc)
      p cc
    end
    
    respond_to do |format|
      format.json      {  render :json => JSON.pretty_generate(tmp) } 
      format.xml       {  render :xml  => tmp }
    end

  end

  #=== /api/vi/triggers PUT メソッドを処理する
  def simpleupdate

    if !params[:property].present?  or params[:property]!= 'run'
      head 400 and return # Bad Request
    end

    if !params[:id].present?
      header 400 and return
    end

    ucode = params[:id]
    ucode = 'ucode_' + params[:id] unless /ucode_/ =~ params[:id]

    find_hash = {'ucode' => ucode }

    m = Mongo::Connection.new( MONGO_SERVER ,MONGO_PORT)
    db = m.db(MONGO_DB)
    update_hash = { '$set' => { "run" => true} }
    db[MONGO_DB].update(find_hash, update_hash)


    head 204

  end

  #=== /api/vi/triggers DELETE メソッドを処理する
  def destroy
    
    if !params[:id].present? then
      head 400 and return # Bad Request
    end

    ucode = params[:id]
    ucode = 'ucode_' + params[:id] unless /ucode_/ =~ params[:id]

    m = Mongo::Connection.new( MONGO_SERVER ,MONGO_PORT)
    db = m.db(MONGO_DB)
    coll = db.collection(MONGO_COLLECTION)

    find_hash = { 'ucode' => ucode }

    cursor = coll.find( find_hash )

    if !cursor.has_next? then
      head :not_found and return
    end

    coll.remove( find_hash )

    head 204

  end

  #=== /api/vi/triggers DELETE メソッドを処理する
  def simpledestroy

    if !params[:property].present?  or params[:property]!= 'run'
      head 400 and return # Bad Request
    end

    if !params[:id].present?
      header 400 and return
    end

    ucode = params[:id]
    ucode = 'ucode_' + params[:id] unless /ucode_/ =~ params[:id]

    find_hash = {'ucode' => ucode }

    m = Mongo::Connection.new( MONGO_SERVER ,MONGO_PORT)
    db = m.db(MONGO_DB)
    update_hash = { '$set' => { "run" => false} }
    db[MONGO_DB].update(find_hash, update_hash)

    head 204

  end


  def ucodeDistributor(objs=nil)
    # client = Mongo::MongoClient.new('pmc.opendata.ubin.jp', MONGO_PORT)
    # client.add_auth('ucode_distributor', 'opendata','0pendata')
    # client.apply_saved_authentication
    # db = client['ucode_distributor']
    # coll = db['ucodes']
    # doc = coll.find_one({"used"=>false})
    # if objs != nil
    #   p doc.merge! objs
    # end
    # doc['used']=true
    # coll.save doc
    # return doc["ucode"]
    return '00001C00000000000001000003000' + format("%X",rand(0x700))
  end

  
end
