
package pmc;

import java.io.*;
import java.io.Reader;
import java.util.*;

import org.openrdf.model.*;
import org.openrdf.model.impl.*;
import org.openrdf.repository.Repository;
import org.openrdf.repository.RepositoryConnection;
import org.openrdf.repository.RepositoryException;
import org.openrdf.repository.http.HTTPRepository;
import org.openrdf.rio.RDFParser;
import org.openrdf.rio.RDFParseException;
import org.openrdf.rio.RDFHandlerException;
import org.openrdf.rio.ntriples.NTriplesParser;
import org.openrdf.rio.rdfxml.RDFXMLParser;
import org.openrdf.rio.helpers.StatementCollector;

public class Sesamedelete
{
   private static String SESAME_SERVER =
       "http://sesame.opendata.ubin.jp:8080/openrdf-sesame";
   
    public static int delete(
        Reader in, RDFParser parser, String repository, URI context )
        throws RDFHandlerException, RDFParseException, IOException,RepositoryException {
        int b = 0;
        Repository myRepository = new HTTPRepository(SESAME_SERVER, repository);
        myRepository.initialize();
        RepositoryConnection conn = myRepository.getConnection();

        StatementCollector hdr = new StatementCollector(new ArrayList<Statement>());
        parser.setRDFHandler(hdr);
        parser.parse(in, "");

        for (Iterator<Statement> i = hdr.getStatements().iterator(); i.hasNext();){

            Statement st = (Statement)i.next();
            if ( !conn.hasStatement(st,true, context) ){
                b = 1;
                break;
            }
        }

        if (b == 0){
            conn.remove(hdr.getStatements(), context);
        } 

        conn.commit();
        conn.close();
        return b;
    }
    public static void main( String args[] ) throws Exception
        {
            // <cmd> -n(ntriples input file) -x(RDF/XML inputt file) -r(repositoryID)
            //       -g(URI of Named Graph)
            Reader in = null;
            RDFParser parser = null;
            String repository = "opendata";
            URI context = null;
            for (int i=0; i<args.length; i++) {
                if (args[i].charAt(0) == '-') {
                    switch(args[i].charAt(1)) {
                    case 'n':
                        in = new StringReader(args[i].substring(2));
                        parser = new NTriplesParser();
                        break;
                    case 'x':
                        in = new StringReader(args[i].substring(2));
                        parser = new RDFXMLParser();
                        break;
                    case 'r':
                        repository = args[i].substring(2);
                        break;
                    case 'g':
                        context = new URIImpl(args[i].substring(2));
                        break;
                    }
                }
            }
            if (in == null) {
                in = new BufferedReader(new InputStreamReader(System.in));
            }
            if (parser == null) {
                parser = new RDFXMLParser();
            }
            delete(in, parser, repository, context);
        }

    public static int results( String args[] ) throws Exception
        {
            // <cmd> -n(ntriples input file) -x(RDF/XML inputt file) -r(repositoryID)
            //       -g(URI of Named Graph)
            Reader in = null;
            RDFParser parser = null;
            String repository = "opendata";
            URI context = null;
            for (int i=0; i<args.length; i++) {
                if (args[i].charAt(0) == '-') {
                    switch(args[i].charAt(1)) {
                    case 'n':
                        in = new StringReader(args[i].substring(2));
                        parser = new NTriplesParser();
                        break;
                    case 'x':
                        in = new StringReader(args[i].substring(2));
                        parser = new RDFXMLParser();
                        break;
                    case 'r':
                        repository = args[i].substring(2);
                        break;
                    case 'g':
                        context = new URIImpl(args[i].substring(2));
                        break;
                    }
                }
            }
            if (in == null) {
                in = new BufferedReader(new InputStreamReader(System.in));
            }
            if (parser == null) {
                parser = new RDFXMLParser();
            }
            return delete(in, parser, repository, context);
        }
}
